/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  wait.c 
 *
 *  Copyright (C) 2001 by Michiel Ronsse, Ghent University, Belgium
 *
 *  This file is part of JiTI86 (http://www.elis.rug.ac.be/~ronsse/jiti/)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * $Author: ronsse $
 * $Date: 2001/10/25 13:46:01 $
 * $Log: wait.c,v $
 * Revision 1.2  2001/10/25 13:46:01  ronsse
 * Initial commit
 *
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * This JiTI86 does ...<something very useful>...
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */




// test hoelang er gewacht moet worden op een semafoor, mutex

#include <pthread.h>
#include <semaphore.h>
#include <errno.h>
#include "jiti.h"

////////////////////////////////////////////////////////////////////////////////////////////

#define AANTAL_INSTR_FUNC     2

#define PTHREAD_MUTEX_LOCK    0
#define SEM_WAIT              1

int dr_pthread_mutex_lock(pthread_mutex_t *mutex);
int dr_sem_wait(sem_t * sem);

struct _reloc_info_ {

  char function[50];
  unsigned real_address;
  unsigned instr_address;

} reloc_info[AANTAL_INSTR_FUNC] = {

  {"pthread_mutex_lock",      0, (unsigned)dr_pthread_mutex_lock},     // 0
  {"sem_wait",                0, (unsigned)dr_sem_wait},               // 1
};

////////////////////////////////////////////////////////////////////////////////////////////

unsigned m_total,m_busy;
unsigned s_total,s_busy;

////////////////////////////////////////////////////////////////////////////////////////////

int dr_pthread_mutex_lock(pthread_mutex_t *mutex){
  int status;

  if ((status=pthread_mutex_trylock(mutex))==EBUSY) { 
    status = (*(int(*)(pthread_mutex_t*))reloc_info[PTHREAD_MUTEX_LOCK].real_address)(mutex);
    m_busy++;
  }

  m_total++;

  return status;

}               

////////////////////////////////////////////////////////////////////////////////////////////

int dr_sem_wait(sem_t * sem){
  int status;
  int test;

  sem_getvalue(sem, &test);

  printf("[%d]\n", test);

  if ((status=sem_trywait(sem))==EAGAIN) { 
    status = (*(int(*)(sem_t*))reloc_info[SEM_WAIT].real_address)(sem);
    s_busy++;
  }
  
  s_total++;
  
  return status;
}

////////////////////////////////////////////////////////////////

_wait_done(){
  printf("\n\n\t>> Aantal mutex_lock-operaties: %d, waarvan %d blokkerende (%f%%) <<\n",
	 m_total, m_busy, m_busy*100.0/m_total);
  printf("\n\n\t>> Aantal sem_wait-operaties:   %d, waarvan %d blokkerende (%f%%) <<\n\n\n",
	 s_total, s_busy, s_busy*100.0/s_total);
}

////////////////////////////////////////////////////////////////////////////////////////////

_wait_init(){
  int i=0;

  fprintf(jiti_tty, "Contention\n");
  
  // onderschep alle synchronisatiefuncties
  while (i<AANTAL_INSTR_FUNC){
    reloc_info[i].real_address = jiti_callback(reloc_info[i].function, reloc_info[i].instr_address);
    i++;
  }
  
  // onderschep het beeindigen v/h programma
  jiti_callback("#STOP#", (unsigned)_wait_done);
  
}
 
////////////////////////////////////////////////////////////////////////////////////////////
                                                                                       
INIT(_wait_init);   
