/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  dynlib.h 
 *
 *  Copyright (C) 2002 by Jonas Maebe, Ghent University, Belgium
 *
 *  This file is part of JiTI86 (http://www.elis.rug.ac.be/~ronsse/jiti/)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * $Author: jmaebe $
 * $Date: 2002/03/11 21:37:29 $
 * $Log: dynlib.h,v $
 * Revision 1.1.2.3  2002/03/11 21:37:29  jmaebe
 * * forgot to commit, see revision 1.7.2.32 for the log message
 *
 * Revision 1.1.2.2  2002/02/21 14:27:23  jmaebe
 * * the gathering of the memory regions occupied by dynlibs is now done from
 *   /proc/self/maps (like in jiti-malloc) -> ld.so is now also found.
 *
 * Revision 1.1.2.1  2002/02/12 16:47:20  jmaebe
 * + initial implementation of instrumenting of dynamically loaded libraries,
 *   but not yet working (even main(void) {} crashes :). Also, some backends
 *   which have to be modified before they can work with this new feature
 *   haven't been adapted yet. Compiler with -DINSTRUMENT_DYNLIBS to include
 *   the functionality (it's even required currently, because there's a
 *   reference to ddelta (dynlib delta) in handlers.s which can't be disabled
 *   using a conditional. Method used: separate clone for the dynlibs (thanks
 *   for the idea, Michiel :)
 *
 *
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * Common include file for JiTI86.
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


#ifndef __DYNLIB_H__
#define __DYNLIB_H__

#include <unistd.h>

extern size_t _dynlibs_base;
extern size_t _dynlibs_size;

extern unsigned libpthread_base;
extern unsigned libpthread_top;

void get_dynlibs_info(void);

#endif //__DYNLIB_H__

